'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactWidgets = require('react-widgets');

var _reduxAutoformUtils = require('redux-autoform-utils');

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimePicker = function (_Component) {
    _inherits(DateTimePicker, _Component);

    function DateTimePicker() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, DateTimePicker);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(DateTimePicker)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getFormat = function (format, type, formats) {
            if (!type) {
                throw Error('\'type\' should be truthy');
            }

            if (!formats) {
                throw Error('\'localizer\' should be truthy');
            }

            if (format) {
                return format;
            }

            switch (type) {
                case 'datetime':
                    return formats.default;
                case 'date':
                    return formats.date;
                case 'time':
                    return formats.time;
                default:
                    throw Error('Invalid type. Type: ' + type);
            }
        }, _this.setReactWidgetsProps = function (props, type) {
            if (!props) {
                throw Error('\'props\' should be truthy');
            }

            if (!type) {
                throw Error('\'type\' should be truthy');
            }

            switch (type) {
                case 'time':
                    props.calendar = false;
                    break;
                case 'date':
                    props.time = false;
                    break;
            }
        }, _this.onChange = function (date, dateAsString) {
            var onChange = _this.props.onChange;

            onChange(dateAsString);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    /**
     * Returns the format prop for the given DateTimePicker props
     * @param format
     * @param type
     * @param formats
     * @returns {*}
     */


    /**
     * Sets ReactWidgetsDateTimePicker props depending on the the type metadata
     * @param props
     * @param type
     */


    _createClass(DateTimePicker, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var value = _props.value;
            var name = _props.name;
            var displayName = _props.displayName;
            var help = _props.help;
            var error = _props.error;
            var touched = _props.touched;
            var onBlur = _props.onBlur;
            var format = _props.format;
            var type = _props.type;
            var fieldLayout = _props.fieldLayout;

            var localizer = (0, _reduxAutoformUtils.getDateLocalizer)();

            if (typeof value == 'string') {
                if (value == '') {
                    value = undefined;
                } else {
                    format = this.getFormat(format, type, localizer.formats);
                    value = localizer.parse(value, format);
                }
            }

            var reactWidgetsProps = { value: value, displayName: displayName, onChange: this.onChange, onBlur: onBlur, format: format };
            var formGroupProps = { error: error, touched: touched, displayName: displayName, name: name, help: help, fieldLayout: fieldLayout };

            this.setReactWidgetsProps(reactWidgetsProps, type);

            return _react2.default.createElement(
                _FormGroup2.default,
                formGroupProps,
                _react2.default.createElement(_reactWidgets.DateTimePicker, reactWidgetsProps)
            );
        }
    }]);

    return DateTimePicker;
}(_react.Component);

DateTimePicker.propTypes = {
    value: _react.PropTypes.any,
    onChange: _react.PropTypes.func.isRequired,
    displayName: _react.PropTypes.string,
    name: _react.PropTypes.string.isRequired,
    error: _react.PropTypes.string,
    format: _react.PropTypes.string
};
exports.default = DateTimePicker;
module.exports = exports['default'];