'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _Input = require('../common/Input');

var _Input2 = _interopRequireDefault(_Input);

var _reactSelectPlus = require('react-select-plus');

var _reactSelectPlus2 = _interopRequireDefault(_reactSelectPlus);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_Component) {
    _inherits(Select, _Component);

    function Select() {
        var _Object$getPrototypeO;

        var _temp, _this, _ret;

        _classCallCheck(this, Select);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Select)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.getOptions = function () {
            var options = _this.props.options;


            return options.map(function (item, index) {
                return _react2.default.createElement(
                    'option',
                    { key: index, value: item.value },
                    item.text
                );
            });
        }, _this.fetchItems = function () {
            var options = _this.props.options;


            return (0, _isomorphicFetch2.default)(options.url).then(function (response) {
                return response.json();
            }).then(function (json) {
                return { options: json };
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Select, [{
        key: 'render',
        value: function render() {
            var _props = this.props;
            var value = _props.value;
            var name = _props.name;
            var displayName = _props.displayName;
            var help = _props.help;
            var error = _props.error;
            var touched = _props.touched;
            var onChange = _props.onChange;
            var _onBlur = _props.onBlur;
            var fieldLayout = _props.fieldLayout;
            var options = _props.options;

            var formGroupProps = { error: error, touched: touched, displayName: displayName, name: name, help: help, fieldLayout: fieldLayout };

            if (options && Array.isArray(options)) {
                return _react2.default.createElement(
                    _Input2.default,
                    _extends({ componentClass: 'select' }, this.props),
                    this.getOptions()
                );
            } else if (options.url) {
                var selectProps = {
                    value: value,
                    name: name,
                    onChange: onChange,
                    onBlur: function onBlur(event) {
                        return _onBlur();
                    },
                    valueKey: options.value ? options.value : 'value',
                    labelKey: options.label ? options.label : 'label'
                };

                return _react2.default.createElement(
                    _FormGroup2.default,
                    formGroupProps,
                    _react2.default.createElement(_reactSelectPlus2.default.Async, _extends({}, selectProps, { loadOptions: this.fetchItems }))
                );
            }

            return false;
        }
    }]);

    return Select;
}(_react.Component);

Select.propTypes = {
    value: _react.PropTypes.any,
    onChange: _react.PropTypes.func.isRequired,
    placeholder: _react.PropTypes.string,
    displayName: _react.PropTypes.string,
    name: _react.PropTypes.string.isRequired,
    error: _react.PropTypes.string,
    addonBefore: _react.PropTypes.string,
    addonAfter: _react.PropTypes.string
};
exports.default = Select;
module.exports = exports['default'];